#ifndef CHIP_8
#define CHIP_8

#include <stdlib.h>
#include <stdbool.h>
#include <SDL2/SDL.h>
#include <stdint.h>

#include "log.h"

#include "keyboard.h"
#include "graphics.h"
#include "controller.h"
#include "print.h"

#define MEMSIZE 4096
#define WIDTH 640
#define HEIGHT 320
std::stringstream debugLogStream;
uint16_t opcode;
uint8_t memory[(MEMSIZE)];
uint8_t v[16];
uint16_t I;
uint16_t PC;

uint8_t gfx[64 * 32];
uint8_t chip8_fontset[80] =
	{
		0xF0, 0x90, 0x90, 0x90, 0xF0, // 0
		0x20, 0x60, 0x20, 0x20, 0x70, // 1
		0xF0, 0x10, 0xF0, 0x80, 0xF0, // 2
		0xF0, 0x10, 0xF0, 0x10, 0xF0, // 3
		0x90, 0x90, 0xF0, 0x10, 0x10, // 4
		0xF0, 0x80, 0xF0, 0x10, 0xF0, // 5
		0xF0, 0x80, 0xF0, 0x90, 0xF0, // 6
		0xF0, 0x10, 0x20, 0x40, 0x40, // 7
		0xF0, 0x90, 0xF0, 0x90, 0xF0, // 8
		0xF0, 0x90, 0xF0, 0x10, 0xF0, // 9
		0xF0, 0x90, 0xF0, 0x90, 0x90, // A
		0xE0, 0x90, 0xE0, 0x90, 0xE0, // B
		0xF0, 0x80, 0x80, 0x80, 0xF0, // C
		0xE0, 0x90, 0x90, 0x90, 0xE0, // D
		0xF0, 0x80, 0xF0, 0x80, 0xF0, // E
		0xF0, 0x80, 0xF0, 0x80, 0x80  // F
};

uint8_t delay_timer;
uint8_t sound_timer;

uint16_t stack[16];
uint16_t sp;

uint8_t keyboard[16];

uint_fast8_t drawflag;

#endif
